//------------------------------------------------------------------+
//#property link      "www.forex-tsd.com"   Mladen 15 March 2012    |
//#property copyright "www.forex-tsd.com"                           |
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  C'0,0,200'
#property indicator_color2  C'200,0,0'
#property indicator_color3  C'200,0,0'
#property indicator_color4  C'0,0,200'
#property indicator_color5  White
#property indicator_color6  Yellow 
#property indicator_width1  20
#property indicator_width3  20
#property indicator_width5  1
#property indicator_width6  1
#property indicator_level1  0
#property indicator_level2   76.4
#property indicator_level3  -76.4
#property indicator_levelcolor Chartreuse

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern double Period1                   =   12;//32
extern double Period2                   =   12;
extern double Period3                   =   3;
extern int    Price                     = PRICE_CLOSE;
extern bool   divergenceVisible         = false;//********* NB
extern bool   divergenceOnValuesVisible = false;
extern bool   divergenceOnChartVisible  = false;
extern color  divergenceBullishColor    = Aqua;
extern color  divergenceBearishColor    = Yellow;
extern string divergenceUniqueID        = "Blau tsi divergence1";
extern bool   Interpolate               = true;
extern bool   alertsOn                  = false;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsEmail               = false;
extern bool   ShowArrows                = false;
extern bool   ShowArrowsOnZeroCross     = false;
extern string ArrowsIdentifier          = "BlauTSI arrows";
extern double ArrowsUpGap1              = 0.15;
extern double ArrowsUpGap2              = 0.25;
extern double ArrowsDownGap1            = 0.55;
extern double ArrowsDownGap2            = 0.65;
extern color  ArrowUpColor1             = Aqua;
extern int    ArrowUpWidth1             = 2;
extern int    ArrowUpCode1              = 233;
extern color  ArrowDownColor1           = Yellow; 
extern int    ArrowDownWidth1           = 2; 
extern int    ArrowDownCode1            = 234;
extern color  ArrowUpColor2             = Aqua;
extern int    ArrowUpWidth2             = 2;
extern int    ArrowUpCode2              = 241;
extern color  ArrowDownColor2           = Yellow; 
extern int    ArrowDownWidth2           = 2; 
extern int    ArrowDownCode2            = 242;
extern bool   ShowHistogram             = true;

double tsi[];
double tsihuu[];
double tsihud[];
double tsihdd[];
double tsihdu[];
double signal[];
double slope[];
double trend[];

//
//
//
//
//

string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
bool   calculateMa;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (ShowHistogram) type = DRAW_HISTOGRAM;
   IndicatorBuffers(8);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, type);
   SetIndexBuffer(1,tsihud); SetIndexStyle(1, type);
   SetIndexBuffer(2,tsihdd); SetIndexStyle(2, type);
   SetIndexBuffer(3,tsihdu); SetIndexStyle(3, type);
   SetIndexBuffer(4,tsi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");
      if (calculateValue)
      {
         int s = StringFind(divergenceUniqueID,":",0);
               shortName = divergenceUniqueID;
               divergenceUniqueID = StringSubstr(divergenceUniqueID,0,s);
               return(0);
      }            
      timeFrame = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      shortName = divergenceUniqueID+": "+timeFrameToString(timeFrame)+" true strength index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")";
      IndicatorShortName(shortName);   
   return(0);
}
int deinit()
{
   int lookForLength = StringLen(divergenceUniqueID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == divergenceUniqueID) ObjectDelete(name);
      }
   lookForLength = StringLen(ArrowsIdentifier);
      for (i=ObjectsTotal(); i>= 0; i--)
      {
         name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
      }
      
   return(0); 
}

//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

double work[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tsihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(work)!=Bars) ArrayResize(work,Bars);
      
      //
      //
      //
      //
      //
      
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1);
         double ava = iEma(iEma(MathAbs(priceDiff),Period1,i,2),Period2,i,3);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            tsihuu[i] = EMPTY_VALUE;
            tsihud[i] = EMPTY_VALUE;
            tsihdd[i] = EMPTY_VALUE;
            tsihdu[i] = EMPTY_VALUE;
            signal[i] = iEma(tsi[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
            work[r]  = work[r-1];
               if (tsi[i] > tsi[i+1])  slope[i] =  1;
               if (tsi[i] < tsi[i+1])  slope[i] = -1;
               if (tsi[i] > signal[i]) trend[i] =  1;
               if (tsi[i] < signal[i]) trend[i] = -1;
               if (tsi[i] > 0)         work[r]  =  1;
               if (tsi[i] < 0)         work[r]  = -1;
               if (tsi[i]>0)
               if (slope[i]==1)
                     tsihuu[i] = tsi[i];
               else  tsihud[i] = tsi[i];
               if (tsi[i]<0)
               if (slope[i]==1)
                     tsihdu[i] = tsi[i];
               else  tsihdd[i] = tsi[i];
            if (divergenceVisible)
            {
              CatchBullishDivergence(tsi,i);
              CatchBearishDivergence(tsi,i);
            } 
            manageArrow(i);
      }
      manageAlerts();
      return(0);
   }   
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         tsi[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ShowArrows,ShowArrowsOnZeroCross,ArrowsIdentifier,ArrowsUpGap1,ArrowsUpGap2,ArrowsDownGap1,ArrowsDownGap2,ArrowUpColor1,ArrowUpWidth1,ArrowUpCode1,ArrowDownColor1,ArrowDownWidth1,ArrowDownCode1,ArrowUpColor2,ArrowUpWidth2,ArrowUpCode2,ArrowDownColor2,ArrowDownWidth2,ArrowDownCode2,4,y);
         signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ShowArrows,ShowArrowsOnZeroCross,ArrowsIdentifier,ArrowsUpGap1,ArrowsUpGap2,ArrowsDownGap1,ArrowsDownGap2,ArrowUpColor1,ArrowUpWidth1,ArrowUpCode1,ArrowDownColor1,ArrowDownWidth1,ArrowDownCode1,ArrowUpColor2,ArrowUpWidth2,ArrowUpCode2,ArrowDownColor2,ArrowDownWidth2,ArrowDownCode2,5,y);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ShowArrows,ShowArrowsOnZeroCross,ArrowsIdentifier,ArrowsUpGap1,ArrowsUpGap2,ArrowsDownGap1,ArrowsDownGap2,ArrowUpColor1,ArrowUpWidth1,ArrowUpCode1,ArrowDownColor1,ArrowDownWidth1,ArrowDownCode1,ArrowUpColor2,ArrowUpWidth2,ArrowUpCode2,ArrowDownColor2,ArrowDownWidth2,ArrowDownCode2,6,y);
         tsihuu[i] = EMPTY_VALUE;
         tsihud[i] = EMPTY_VALUE;
         tsihdd[i] = EMPTY_VALUE;
         tsihdu[i] = EMPTY_VALUE;
            if (tsi[i]>0)
               if (slope[i]==1)
                     tsihuu[i] = tsi[i];
               else  tsihud[i] = tsi[i];
            if (tsi[i]<0)
               if (slope[i]==1)
                     tsihdu[i] = tsi[i];
               else  tsihdd[i] = tsi[i];

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  tsi[i+k]    = tsi[i]    + (tsi[i+n]    - tsi[i]   )*k/n;
                  signal[i+k] = signal[i] + (signal[i+n] - signal[i])*k/n;
               }                  
   }
   for (i=limit; i>=0; i--)
   {
      if (tsihuu[i] != EMPTY_VALUE) tsihuu[i] = tsi[i];
      if (tsihud[i] != EMPTY_VALUE) tsihud[i] = tsi[i];
      if (tsihdu[i] != EMPTY_VALUE) tsihdu[i] = tsi[i];
      if (tsihdd[i] != EMPTY_VALUE) tsihdd[i] = tsi[i];
   }
   
   //
   //
   //
   //
   //

   return(0);
   
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}



//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
//
//
//
//
//

void CatchBullishDivergence(double& values[], int i)
{
   i++;
            ObjectDelete(divergenceUniqueID+"l"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"l"+"os" + DoubleToStr(Time[i],0));            
   if (!IsIndicatorLow(values,i)) return;  

   //
   //
   //
   //
   //

   int currentLow = i;
   int lastLow    = GetIndicatorLastLow(values,i+1);
      if (values[currentLow] > values[lastLow] && Low[currentLow] < Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],divergenceBullishColor,STYLE_SOLID);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow],divergenceBullishColor,STYLE_SOLID);
      }
      if (values[currentLow] < values[lastLow] && Low[currentLow] > Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], divergenceBullishColor, STYLE_DOT);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow], divergenceBullishColor, STYLE_DOT);
      }
}

//
//
//
//
//

void CatchBearishDivergence(double& values[], int i)
{
   i++; 
            ObjectDelete(divergenceUniqueID+"h"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"h"+"os" + DoubleToStr(Time[i],0));            
   if (IsIndicatorPeak(values,i) == false) return;

   //
   //
   //
   //
   //
      
   int currentPeak = i;
   int lastPeak = GetIndicatorLastPeak(values,i+1);
      if (values[currentPeak] < values[lastPeak] && High[currentPeak]>High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],divergenceBearishColor,STYLE_SOLID);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak],divergenceBearishColor,STYLE_SOLID);
      }
      if(values[currentPeak] > values[lastPeak] && High[currentPeak] < High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], divergenceBearishColor, STYLE_DOT);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak], divergenceBearishColor, STYLE_DOT);
      }
}

//
//
//
//
//

bool IsIndicatorPeak(double& values[], int i) { return(values[i] >= values[i+1] && values[i] > values[i+2] && values[i] > values[i-1]); }
bool IsIndicatorLow( double& values[], int i) { return(values[i] <= values[i+1] && values[i] < values[i+2] && values[i] < values[i-1]); }

int GetIndicatorLastPeak(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] >= values[i+1] && values[i] > values[i+2] && values[i] >= values[i-1] && values[i] > values[i-2]) return(i);
   return(-1);
}
int GetIndicatorLastLow(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] <= values[i+1] && values[i] < values[i+2] && values[i] <= values[i-1] && values[i] < values[i-2]) return(i);
   return(-1);
}

//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                  
//+---------------------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string   label = divergenceUniqueID+first+"os"+DoubleToStr(t1,0);
    
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}
void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   
   string label = divergenceUniqueID+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//--------------------------------------------------------------------------------------------------------------------+
//
//--------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows || ShowArrowsOnZeroCross)
   {
      ObjectDelete(ArrowsIdentifier+Time[i]);         
      ObjectDelete(ArrowsIdentifier+Time[i]+":2");         
            
      //
      //
      //
      //
      //
           
      if (ShowArrows && trend[i] != trend[i+1])
      {
         string name = ArrowsIdentifier+Time[i];
         if (trend[i] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap1*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowUpCode1);
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor1);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth1);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap1*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowDownCode1);
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor1);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth1);
         }
      }
      
      //
      //
      //
      //
      //
      
      int r = Bars-i-1;
      if (ShowArrowsOnZeroCross && work[r] != work[r-1])
      {
         name = ArrowsIdentifier+Time[i]+":2";
         if (work[r] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap2*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowUpCode2);
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor2);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth2);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap2*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,ArrowDownCode2);
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor2);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth2);
         }
      }
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Blau ergodic tsi trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Blau ergodic tsi"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------------------------------+
//
//-------------------------------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
//==================================================================+